unit Store_External_Pas_Test;

interface

{$REGION '<TESTME>'}      {$IFDEF TESTME}
uses System.SysUtils
  ,TestMe,TestMe_Types
  ,TestCodeType,TestCodeLevelUnits
;

  type
  TClassPublic_Test=class
    class var F_pIndexApp,F_pIndexUnit,F_pIndexClass:TPIndexValue;
    class Procedure _RegisterMethod;
    class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
  end;

{$ENDIF}  {$ENDREGION}

implementation

{$REGION '<TESTME>'}      {$IFDEF TESTME}

 uses
  Store_External_Pas
  ;


  type
  TClassPrivate_Test=class
    class var F_pIndexApp,F_pIndexUnit,F_pIndexClass:TPIndexValue;
    class Procedure _RegisterMethod;
    class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
  end;



{ TClassPublic_Test }
 type
   TTestMethod = (
   tmCreate
   ,tmFree

   ,tmUnitPublic_Var
   ,tmUnitPublic_VarMethod
   ,tmUnitPrivate_Var
   ,tmUnitPrivate_Method

   ,tmClassPublic_Pivate_Var
   ,tmClassPublic_Pivate_Method
   ,tmClassPublic_Protected_Var
   ,tmClassPublic_Protected_Method
   ,tmClassPublic_Public_Var
   ,tmClassPublic_Public_Method

   ,tmClassPrivate_Pivate_Var
   ,tmClassPrivate_Pivate_Method
   ,tmClassPrivate_Protected_Var
   ,tmClassPrivate_Protected_Method
   ,tmClassPrivate_Public_Var
   ,tmClassPrivate_Public_Method

    );




class procedure TClassPublic_Test._RegisterMethod;
begin
 if not GetTestMe.bIsTestCode then Exit;

 with GetTestMe.ITestCode do begin
  if not ISetDefaultIndClassUnitApp(F_pIndexClass,F_pIndexUnit,F_pIndexApp) then exit; // Set position
   IRegisterMethod(tmCreate  ,'tmCreate','',pAddOneEmptyParam,0 );// Test methods
   IRegisterMethod(tmFree    ,'tmFree',''  ,pAddOneEmptyParam,MAX_POS_TESTMETHOD );// Test methods

   IRegisterMethod(tmUnitPublic_Var  ,'tmUnitPublic_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmUnitPublic_VarMethod  ,'tmUnitPublic_VarMethod','',pAddOneEmptyParam );// Test methods

   IRegisterMethod(tmClassPublic_Pivate_Var  ,'tmClassPublic_Pivate_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Pivate_Method  ,'tmClassPublic_Pivate_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Protected_Var  ,'tmClassPublic_Protected_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Protected_Method  ,'tmClassPublic_Protected_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Public_Var  ,'tmClassPublic_Public_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Public_Method  ,'tmClassPublic_Public_Method','',pAddOneEmptyParam );// Test methods

 end; //withend;
end;


  type
   TClassPublic_Hack=class(TClassPublic);

   TClassPublic_DirtyHack = class
  private
   ClassPublic_Pivate_Var:Integer;
   end;

class function TClassPublic_Test._TestMethods(
  IMethod: IRunMethodParam): TTestResultParam;
begin
 Result:=trErrRegister;
 case TTestMethod(IMethod.IGetNumParamUser)  of
   tmCreate:
          begin
           if L_ClassPublic=nil then begin
              L_ClassPublic:=TClassPublic.Create;
               result:=trOk;
           end else
               result:=trError;
          end;
   tmFree:
          begin
           if L_ClassPublic<>nil then begin
             FreeAndNil(L_ClassPublic);
             result:=trOk;
           end else
               result:=trError;
          end;
   tmUnitPublic_Var,tmUnitPublic_VarMethod
          :begin
              UnitPublic_Method(2,2);
              if UnitPublic_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPublic_Pivate_Var
          :begin
              TClassPublic_DirtyHack(L_ClassPublic).ClassPublic_Pivate_Var:=2+2;
              if TClassPublic_DirtyHack(L_ClassPublic).ClassPublic_Pivate_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPublic_Pivate_Method
          :begin
           {
              TClassPublic_Hack(L_ClassPublic).ClassPublic_Pivate_Method(2,2);
              if L_ClassPublic.ClassPublic_Pivate_Var=4 then
               result:=trOk
              else
              }
               result:=trError;
           end;
   tmClassPublic_Protected_Var,tmClassPublic_Protected_Method
          :begin
              TClassPublic_Hack(L_ClassPublic).ClassPublic_Protected_Method(2,2);
              if TClassPublic_Hack(L_ClassPublic).ClassPublic_Protected_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPublic_Public_Var,tmClassPublic_Public_Method
          :begin
              L_ClassPublic.ClassPublic_Public_Method(2,2);
              if L_ClassPublic.ClassPublic_Public_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
  end; // case

end;


{ TClassPrivate_Test }

class procedure TClassPrivate_Test._RegisterMethod;
begin
 if not GetTestMe.bIsTestCode then Exit;

 with GetTestMe.ITestCode do begin
  if not ISetDefaultIndClassUnitApp(F_pIndexClass,F_pIndexUnit,F_pIndexApp) then exit; // Set position
   IRegisterMethod(tmCreate  ,'tmCreate','',pAddOneEmptyParam,0 );// Test methods
   IRegisterMethod(tmFree    ,'tmFree',''  ,pAddOneEmptyParam,MAX_POS_TESTMETHOD );// Test methods

   IRegisterMethod(tmUnitPrivate_Var  ,'tmUnitPrivate_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmUnitPrivate_Method  ,'tmUnitPrivate_Method','',pAddOneEmptyParam );// Test methods

   IRegisterMethod(tmClassPrivate_Pivate_Var  ,'tmClassPrivate_Pivate_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Pivate_Method  ,'tmClassPrivate_Pivate_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Protected_Var  ,'tmClassPrivate_Protected_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Protected_Method  ,'tmClassPrivate_Protected_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Public_Var  ,'tmClassPrivate_Public_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Public_Method  ,'tmClassPrivate_Public_Method','',pAddOneEmptyParam );// Test methods
 end;
end;

class function TClassPrivate_Test._TestMethods(
  IMethod: IRunMethodParam): TTestResultParam;
begin
 Result:=trErrRegister;
 case TTestMethod(IMethod.IGetNumParamUser)  of
   tmCreate:
          begin
           {
           if L_ClassPrivate=nil then begin
              L_ClassPrivate:=TClassPrivate.Create;
               result:=trOk;
           end else
          }
               result:=trError;
          end;
   tmFree:
          begin
           {
           if L_ClassPrivate<>nil then begin
             FreeAndNil(L_ClassPrivate);
             result:=trOk;
           end else
           }
               result:=trError;
          end;
   tmUnitPrivate_Var,tmUnitPrivate_Method
          :begin
              {
              UnitPrivate_Method(2,2);
              if UnitPrivate_Var=4 then
               result:=trOk
              else
              }
               result:=trError;
           end;
   tmClassPrivate_Pivate_Var,tmClassPrivate_Pivate_Method
          :begin
           {
              L_ClassPrivate.ClassPrivate_Pivate_Method(2,2);
              if L_ClassPrivate.ClassPrivate_Pivate_Var=4 then
               result:=trOk
              else
             }
               result:=trError;
           end;
   tmClassPrivate_Protected_Var,tmClassPrivate_Protected_Method
          :begin
            {
              L_ClassPrivate.ClassPrivate_Protected_Method(2,2);
              if L_ClassPrivate.ClassPrivate_Protected_Var=4 then
               result:=trOk
              else
              }
               result:=trError;
           end;
   tmClassPrivate_Public_Var,tmClassPrivate_Public_Method
          :begin
            {
              L_ClassPrivate.ClassPrivate_Public_Method(2,2);
              if L_ClassPrivate.ClassPrivate_Public_Var=4 then
               result:=trOk
              else
             }
               result:=trError;
           end;
 end; // case
end;

initialization

   if GetTestMe.bIsTestCode then begin
     with GetTestMe.ITestCode do begin
       TClassPublic_Test.F_pIndexApp:=IRegisterApplication( hInstance);
       TClassPublic_Test.F_pIndexUnit:=IRegisterUnit(ltApplication,'Store_External_Pas_Test','Store TestCode External File');
       TClassPublic_Test.F_pIndexClass := IRegisterClass(TClassPublic_Test._RegisterMethod,TClassPublic_Test._TestMethods,'TClassPublic_Test','Test access visibility Class');

       TClassPrivate_Test.F_pIndexApp:=TClassPrivate_Test.F_pIndexApp;
       TClassPrivate_Test.F_pIndexUnit:=TClassPrivate_Test.F_pIndexUnit;
       TClassPrivate_Test.F_pIndexClass := IRegisterClass(TClassPrivate_Test._RegisterMethod,TClassPrivate_Test._TestMethods,'TClassPrivate_Test','Test access private  Class');

     end;
   end;


{$ENDIF}  {$ENDREGION}

end.
