(*   Registration
 // 1.Units
  uses ...
{$REGION '<TESTME>'} {$IFDEF TESTME}
   ,TestMeType,TestMeLevelType
{$ENDIF} {$ENDREGION}
 // 2.Class method
{$REGION '<TESTME>'} {$IFDEF TESTME}
        private
          class Procedure _RegisterMethod; // Register TestMethods
          class Function _TestMethods( IMethod:IRunMethodParam    // Test Methods
                            ):TTestResultParam;// Result Test
{$ENDIF} {$ENDREGION}
 // 3. implementation
 // 3.1 Var and types
{$REGION '<TESTME>'} {$IFDEF TESTME}
  L_pIndexUnit,L_pIndexApp
   ,L_pIndexTCalculate:TPIndexValue;

 // Enum test method
  type
   TMethod=(mCreate,mFree,tmDiv);
  ...
class Procedure   _RegisterMethod; // Register TestMethods
begin
 if GetTestMe.bIsTestCode then begin
  with GetTestMe.ITestCode do begin
   // Set position
   if not ISetDefaultIndClassUnitApp(L_pIndexTCalculate,L_pIndexUnit,L_pIndexApp) then Exit;

 // Init
   IRegisterMethod(tmInitBreak,'tmInitBreak','Init var if break test'
   ,pAddOneEmptyParam    // Auto add test parameter
    ,0);                 // First index test position
 // Create class for test
   IRegisterMethod(tmCreate,'tmCreate','Test Create component'
   ,pAddOneEmptyParam    // Auto add test parameter
    ,1);                 // First index test position

 // Free class
   IRegisterMethod(tmFree  ,'tmFree'  ,'Test Free component'
   ,pAddOneEmptyParam    // Auto add test parameter
   ,MAX_POS_TESTMETHOD); // Last index test position
  // Div method
   IRegisterMethod(tmDiv  ,'tmDiv'  ,'Test Div operation');// Test methods
    IRegisterMethodParams([15,5],[3],'15 div 5=3'); // True result
    IRegisterMethodParams([2,2],[1],'2 div 2=4');   // True result
    IRegisterMethodParams([4,4],[4],'4 div 4<>4 True=Error'); // Error
    IRegisterMethodParams([4,4],[4],'4 div 4=4 trError it''s Ok',trError); // Error = Ok
    IRegisterMethodParams([4,0],[4],'4 div 0 (!) Exception'); // Exception
    IRegisterMethodParams([4,0],[4],'4 div 0 (!) trException it''s Ok',trException); // Exception = Ok
 end;// with GetTestMe.ITestMe do begin
end;

class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;// Result Test
begin
 // Break test. Use consruction in cycles
  if IMethod.INeedBreakTest then begin result:=trBreakTest; Exit; end;

 case TTestMethod(IMethod.IGetNumParamUser)  of
   tmInitBreak: begin
                  FreeAndNil(L_oCalc);
                  result:=trOk;
                end;
   tmCreate :begin
       if L_oCalc=nil then begin
        L_oCalc:=TCalc.Create;
        result:=trOk;
       end else
        result:=trError;
     end;
   tmFree  :begin
       if L_oCalc<>nil then begin
        FreeAndNil(L_oCalc);
        result:=trOk;
       end else
        result:=trError;
     end;
   tmDiv
    :begin
       if (L_oCalc.divide(IMethod.IGetArrParam(0).AsInteger,IMethod.IGetArrParam(1).AsInteger) = IMethod.IGetArrResultForTestMethod(0).AsInteger) then
        result:=trOk
       else
        result:=trError;
    end;
 end;//case
end;

 // 3.2 initialization
initialization
 if GetTestMe.bIsTestCode then begin
   with GetTestMe.ITestCode do begin
     L_pIndexApp:=IRegisterApplication(hInstance);
     L_pIndexUnit:=IRegisterUnit(ltMyComponenst,'Calculator','unit Calculator components');
     L_pIndexTCalculate   := IRegisterClass(TCalc._RegisterMethod,TCalc._TestMethods,'TCalc','Class Calculater');
   end;
 end;
{$ENDIF} {$ENDREGION}

 end.


  *)


unit TestCodeType;

interface
  uses
   SysUtils,windows
  ,TestCodeLevelUnits


 ;

  type
 TTestResultParam=(
              trNone=0   // no test
             ,trOk  = 3  // Test complete
             ,trBreakTest    =10 // break test
             ,trError        =13//  Error Test
             ,trException    =16 // Exception in test

    // Error registration
             ,trErrParamCount =30 // Error in number of parameters
             ,trErrParamType  =31 // Error in parameter type (number, string)
             ,trErrRegister   =32 // Error register test

            ,trUnknowResult = 63  // For not create test
             );




type
 TTypeDataStore  = (
  tdsInteger     = 0   ,
  tdsBoolean     = 1   ,
  tdsAnsiChar    = 2   ,
  tdsExtended    = 3   ,
  tdsShortString = 4   , //convert  tdsAnsiString
  tdsPointer     = 5   ,
  tdsPAnsiChar   = 6   ,
  tdsObject      = 7   ,
  tdsClass       = 8   ,
  tdsWideChar    = 9   ,
  tdsPWideChar   = 10  ,
  tdsAnsiString  = 11  ,
  tdsCurrency    = 12  , // convert to tdsExtended
  tdsVariant     = 13  , // disabled, convert to tdsNone
  tdsInterface   = 14  ,
  tdsWideString  = 15  ,
  tdsInt64       = 16  ,
  tdsUnicodeString = 17,
  tdsNone        = 99 // unknow types or unsupported disabled types
  );



// Use when registering a method in IRegisterMethod.
//  Replace the iSortPrioritet parameter with MAX_POS_TESTMETHOD if you need to remove Object.Free being tested
  const
   MAX_POS_TESTMETHOD = $FFFFFFF;


   type
    TPIndexValue=  PInteger;
    TDisableInit=function(var wsErr:WideString):Boolean  of object;

   type
    IResultValue=interface
      ['{999297E2-97B4-4CA8-9FD1-8358C184D84E}']
      Function AsInteger:Integer;
      Function AsBoolean:boolean;
      Function AsObject:TObject;
      Function AsClass:TClass;
      Function AsExtended:Extended;
      Function AsExtended_RecurrDecimal:Extended;  // a recurring decimal
      Function AsCurrency:currency; // convert to tdsExtended
      Function AsVariant:Variant;
      Function AsInterface:IInterface;//Pointer;
      Function AsInt64:int64;

      Function AsDateTime:TDateTime;

      Function AsAnsiChar:AnsiChar;
      Function AsPAnsiChar:PAnsiChar;

      Function AsWideChar:WideChar;
      Function AsPWideChar:PWideChar;

      // use all strings
      Function AsPointer:Pointer;
      //      AsAnsiString:AnsiString;
      Function AsAnsiString_GetSize:integer;
      Function AsAnsiString_GetDataAll(var Dest):integer;
      Function AsAnsiString_GetData(var Dest;iCount:integer;iOffset:Integer=0):integer;

//      Function AsWideString:WideString;
      Function  AsWideString_GetSize:integer;
      Function AsWideString_GetDataAll(var Dest):integer;
      Function AsWideString_GetData(var Dest;iCount:integer;iOffset:Integer=0):integer;

//      Function AsUnicodeString:UnicodeString;
      Function  AsUnicodeString_GetSize:integer;
      Function AsUnicodeString_GetDataAll(var Dest):integer;
      Function AsUnicodeString_GetData(var Dest;iCount:integer;iOffset:Integer=0):integer;


      Function AsType:TTypeDataStore; //Type stores
      Function IsCompareType(tOut:TTypeDataStore):boolean; //Type compatibility check

    end;

   // Buffers
   type
    IResultBuff=interface
    ['{0B0B12B5-7369-4D7D-A07E-A4CE215643E5}']
      Function IsExists:boolean;
      Function AsBuff_Size:integer;
      Function AsBuff_Data(var Dest;iCount:integer;iOffset:Integer=0):integer;
    end;


   type
    IRunMethodParam=interface
     ['{2FF6D5C8-F137-46F0-8A88-FD4BD2C2F93A}']
      function GetAutoConvertParam: Boolean;
      procedure SetAutoConvertParam(const Value: Boolean);

     function IGetNumParamUser:integer; // Number of parameters recorded in the call, to check in the test function
      function IReg_CodeResult_Ok:TTestResultParam; // what type of return that test passed

     // open parameter values for use in tests
     function IGetArrParamCount:integer;
     function IGetArrParam(iIndexValue:integer):IResultValue;
      function IGetArrParamBuff:IResultBuff;
     function IGetArrResultForTestMethodCount:integer;
     function IGetArrResultForTestMethod(iIndexValue:integer):IResultValue;
      function IGetArrReultBuff:IResultBuff;
      Function IsCompareTypes(tStore,tOut:TTypeDataStore):boolean;

     // Count  runs
     function IGetCountRunStep:Integer;
     function IGetCountRun:Integer;
     // get max timeout after which the error
     function IGetMaxTimeOut:Integer;
      // returns a sign of the need to interrupt the test.
       function INeedBreakTest:boolean;
       function INeedBreakTestPointer:PBoolean;
     // autoconvert paramterd in code
       property IAutoConvertParam:Boolean read GetAutoConvertParam write SetAutoConvertParam  ;

    end;


    type
     TTestRegisterMethod = procedure of object;
     TTestMethodsRun     = function( IMethod:IRunMethodParam):TTestResultParam  of object;


   TTestType=(tEmptyParam=0 // not use
    ,tTestCodeOnly=1  // default
   );

   TMethodAddParam = ( pAddManualOnly = 0   // manual add
                      ,pAddOneEmptyParam =1 // auto add empty parameter
                     );



   TParamCheckOption = (poCountParam
                  ,poHardTypeParam
                  );

   TParamCheckOptions = set of TParamCheckOption;

    IRegisterTestCode=interface
    ['{F74FEF67-4EBA-4182-9C42-3580B19BDF61}']
      //  USE ONLY -> LevelTestUnit.pas
      // Samples:    TestCodeLevelUnits.IRegisterLevelUnit(ltApplication,'ltApplication','Applications');
    Procedure IRegisterLevelUnit(vLevelUnit:variant;const wsName,wsDescription:WideString);
    // Register the name of the group in which the application will be
    Procedure  IRegisterGroupApplications(const wsGroupName:WideString='';wsGroupDescription:WideString='');
    // Application registration is required if the application and the DLL are tested simultaneously.
    Function   IRegisterApplication(hInstanceApp:NativeUInt;const wsDescription:WideString='';procNeedDisableInit:TDisableInit=nil;iSortPrioritet:integer=100):TPIndexValue;
    Function IRegisterUnit(vLevelTest:variant // TLevelTestRun -> TestCodeLevelUnits.pas
              ;const sNameUnit:WideString;sDescription:WideString=''
              ;procNeedDisableInit:TDisableInit=nil
              ;iSortPrioritet:integer=100
              ;pIndexApp_NilDefault:TPIndexValue=nil
              ):TPIndexValue;


      Function IRegisterClass(RegMethod:TTestRegisterMethod;TestMethodRun:TTestMethodsRun
                            ;const wsClassName:WideString
                             ;wsDescription:WideString=''
              ;procNeedDisableInit:TDisableInit=nil
                        ;iSortPrioritet:integer=100
                            ;pIndexUnit_NilDefault:TPIndexValue=nil
                            ;pIndexApp_NilDefault:TPIndexValue=nil
                             )
            :TPIndexValue;

    Function IRegisterMethodList(const ArrNames :array of Variant// [vENumMethodName,vENumMethodName] array methods list with empty params
         ;wsNames:WideString   // method names through the separator 'Meth1, Meth2'
         ;wsDescription:WideString=''  // Descriptions  through the separator 'Desc1, Desc2'
         ;chSeparator:WideChar=','  // separator text
         ;iSortPrioritet:integer=100  // create positions default
         ):boolean;// True or False Registrations


    Function IRegisterMethod(vENumMethodName  // custom types
                             :variant
                             ;const wsNamesMethod:WideString
                             ;wsDesc:WideString=''
                             ;tAddParam:TMethodAddParam=pAddManualOnly
                             ;iSortPrioritet:integer=100
                             ;tParamCheckOptions:TParamCheckOptions=[poCountParam{,poHardTypeParam}]
                             ;ttTestType:TTestType=tTestCodeOnly
                             ;pIndexClass_NilDefault:TPIndexValue=nil
                             ;pIndexUnit_NilDefault:TPIndexValue=nil
                            ;pIndexApp_NilDefault:TPIndexValue=nil
           ):boolean;

    Function IRegisterMethodParams(
                      arrParams  // test in params
                       ,arrResultCMP // test check params
                        :array of const;
                       sName:WideString
                       ;ErrCode_Ok:TTestResultParam=trOk
                        ;bIsAutoConvertParam:boolean=True  // AnsiChar to AnsiString,WideChar,WideString;  integer to int64,extended
                        ;iTimeOutMS:Integer=5000 //wait normal work test 5sec
                        ;iCountRun:Integer=1     // count run test
                       ;ttTestType:TTestType=tTestCodeOnly  // test code

                       ;sReserveStrParam:WideString=''
                       ;pIndMethod:TPIndexValue=nil
                       ):boolean;
    Function IRegisterMethodParamsBuff(
                      arrParams
                       ,arrResultCMP
                        :array of const;
                        BuffParam:Pointer;iBuffParamSize:Integer;   // Add buff param
                        BuffResultCMP:Pointer;iBuffResultSize:Integer;
                       sName:WideString
                       ;ErrCode_Ok:TTestResultParam=trOk
                        ;bIsAutoConvertParam:boolean=True
                        ;iTimeOutMS:Integer=5000
                        ;iCountRun:Integer=1
                       ;ttTestType:TTestType=tTestCodeOnly

                       ;sReserveStrParam:WideString=''
                       ;pIndMethod:TPIndexValue=nil
                       ):boolean;

      // Set positions for registrations methods and params
      function ISetDefaultIndClassUnitApp(pIndClass:TPIndexValue;pIndUnit:TPIndexValue=nil;pIndApp:TPIndexValue=nil):boolean;


    end;


// Convert
function Conv_Set2int64(const value;iSize:integer): int64;
Procedure Conv_int642Set(const i64:Int64; var value;iSize:integer);

 // Get Strings
function IMethod_AsAnsiString(const IResValue:IResultValue):AnsiString;
function IMethod_AsWideString(const IResValue:IResultValue):WideString;
function IMethod_AsUnicodeString(const IResValue:IResultValue):UnicodeString;



 // Sleep and Break Test
 Procedure  CPUTSleep_1MS_Break(msec:Cardinal;var bIsBreak:boolean);
 Procedure  CPUTSleep_10MS_Break(msec:Cardinal;var bIsBreak:boolean);
 Procedure  CPUTSleep_100MS_Break(msec:Cardinal;var bIsBreak:boolean);


implementation



 // Break
 Procedure  CPUTSleep_1MS_Break(msec:Cardinal;var bIsBreak:boolean);
 var i:Integer;
 begin
    for i:=0  to msec-1 do begin
     if bIsBreak then exit;
     Sleep(1);
    end; //for
 end;

 Procedure  CPUTSleep_10MS_Break(msec:Cardinal;var bIsBreak:boolean);
 var i:Integer;
  cMod:Cardinal;
 begin
   if msec<10 then
      CPUTSleep_1MS_Break(msec,bIsBreak)
   else begin
      msec:=(msec div 10);
      cMod:=(msec mod 10);
    for i:=0  to msec-1 do begin
     if bIsBreak then exit;
     Sleep(10);
    end; //for
      CPUTSleep_1MS_Break(cMod,bIsBreak);
   end;
 end;

 Procedure  CPUTSleep_100MS_Break(msec:Cardinal;var bIsBreak:boolean);
 var i:Integer;
  cMod:Cardinal;
 begin
   if msec<100 then
      CPUTSleep_10MS_Break(msec,bIsBreak)
   else begin
      msec:=(msec div 100);
      cMod:=(msec mod 100);
    for i:=0  to msec-1 do begin
     if bIsBreak then exit;
     Sleep(100);
    end; //for
      CPUTSleep_10MS_Break(cMod,bIsBreak);
   end;
 end;



 // Get Strings
function IMethod_AsAnsiString(const IResValue:IResultValue):AnsiString;
begin
 if IResValue.IsCompareType(tdsAnsiString) and (IResValue.AsAnsiString_GetSize>0) then begin
   SetLength(Result,IResValue.AsAnsiString_GetSize);
   IResValue.AsAnsiString_GetDataAll(Result[1]);
 end else
  Result:='';
end;
function IMethod_AsWideString(const IResValue:IResultValue):WideString;
begin
 if IResValue.IsCompareType(tdsWideString) and (IResValue.AsWideString_GetSize>0) then begin
   SetLength(Result,IResValue.AsWideString_GetSize);
   IResValue.AsWideString_GetDataAll(Result[1]);
 end else
  Result:='';
end;
function IMethod_AsUnicodeString(const IResValue:IResultValue):UnicodeString;
begin
 if IResValue.IsCompareType(tdsUnicodeString) and (IResValue.AsWideString_GetSize>0) then begin
   SetLength(Result,IResValue.AsUnicodeString_GetSize);
   IResValue.AsUnicodeString_GetDataAll(Result[1]);
 end else
  Result:='';
end;

// Convert
function Conv_Set2int64(const value;iSize:integer): int64;// stdcall;
var i64:Int64;
begin
  if sizeof(i64)<iSize then
   raise Exception.Create('Big size SET');
  move(value,i64,iSize);
  result:=i64;
end;
Procedure Conv_int642Set(const i64:Int64; var value;iSize:integer); //stdcall;
begin
  move(i64,value,iSize);
end;

end.
