//     DLL c     

// {$DEFINE DLL_Load_Res} // NO USE DELPHI DEBUG, RANDOM EXCEPTION BTMemoryModule
(*
  Example of how to connect the module for testing:
  = = = SEND START = = =
  1. Add uses:
 uses
  {$Ifdef TestMe}
  <... >
  {$Endif}
  ....
 2. Add pointer innterface TestMe
type
  TForm1 = class(TForm)
  private
  {$Ifdef TestMe}
  <... >
   F_pIRestMe:PTRecITestMe;
  {$Endif}
  end;
 ....
 3. Connect in TestMeOn32.dll
procedure TForm1.FormCreate(Sender: TObject);
begin
  {$Ifdef TestMe}
  <... >
   F_pIRestMe:=GetTestMe;
   if F_pIRestMe=nil then
    raise Exception.Create('Error load TestMeON.dll');
  {$Endif}
end;
 4. Use
procedure TForm1.btn_SendClick(Sender: TObject);
begin
  {$Ifdef TestMe}
  <... >
   F_pIRestMe.ITestSend.Ok('Hello, I send OK message!');
  {$Endif}
end;
  = = = SEND end = = =
  = = = CODE START = = =
  1. Add uses:
 uses
  {$Ifdef TestMe}
  <... >
  ,TestMeOn ,TestCodeType,TestCodeLevelType
  {$Endif}
  ....
 2. Add methods TestMe in Class
  private
  {$IFDEF TESTME}
  <... >
    class var F_pIRestMe:PTRecITestMe;
    class var F_pIndexUnit,F_pIndexForm:TPIndexValue;
    class Procedure _RegisterMethod;
    class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
  {$ENDIF}


  = = = CODE end = = =

*)

unit TestMe;
 {$I TestMe.inc}

interface
 uses
  SysUtils,windows
  ,TestMe_Types
  ;

Function GetTestMe:PTRecITestMe;


implementation
   uses
    classes

 {$IFDEF DLL_Load_Res}
     ,BTMemoryModule
   {$R DLL32.RES}
 {$ENDIF}

    {$IFDEF TestCODE}
    ,TestCodeType
    {$ENDIF}
    {$IFDEF TestSEND}
    ,TestSendType
    {$ENDIF}

   ;

 {$IFDEF DLL_Load_Res}
   {$R DLL32.RES}
 {$ENDIF}



  {$J+}
 const
   Const_bInit:Boolean = False;
  {$J-}

 var

 L_RecITestMe:TRecITestMe;

   L_bIsLicence:Boolean;


Procedure int_LoadLibrary; forward;


Function GetTestMe:PTRecITestMe;
begin
  if not Const_bInit then begin
      int_LoadLibrary;

   {$IFDEF TestCODE}
    L_RecITestMe.bIsTestCode:=L_RecITestMe.ITestCode<>nil;
   {$ENDIF}
   {$IFDEF TestSEND}
     L_RecITestMe.bIsTestSend:=L_RecITestMe.ITestSend<>nil;
   {$ENDIF}
  end;
    result:=@L_RecITestMe
end;


 type
    TInit=procedure(hInstanceApp:NativeUInt;var bIsDEMO:boolean); stdcall;
    TDoneFree=procedure; stdcall;
    TGetIsLicence=Function(var pData:Pointer;var iSize:integer):boolean; stdcall;
  {$IFDEF TestCODE}
    TGetTestCode=Function (var IRegTestCode:IRegisterTestCode):boolean; stdcall;
  {$ENDIF}
  {$IFDEF TestSEND}
   TGetSendMe=Function (var IRegSendMe:ISendMe):boolean; stdcall;
  {$ENDIF}



 const
 {$IFDEF Win32}
    Cons_DllName='TestMeCode32.dll';
 {$ELSE}
    Cons_DllName='TestMeCode64.dll';
 {$ENDIF}

 var

// RES_DLL
 {$IFDEF DLL_Load_Res}
  L_pDLL_Data:Pointer;
  L_iDLL_Size:Integer;
  L_MemoryModule:PBTMemoryModule;
 {$ENDIF}
  L_hDll:THandle;





Procedure int_LoadLibrary;
var
    init:TInit;
    lic:TGetIsLicence;
    pData:Pointer;
    iSize:Integer;
  {$IFDEF TestCODE}  getCode:TGetTestCode;  {$ENDIF}
  {$IFDEF TestSEND}  getSend:TGetSendMe;    {$ENDIF}


    {$IFDEF DLL_Load_Res}
      ResStream: TResourceStream;
    {$ENDIF}

begin
 if not Const_bInit then begin
   Const_bInit:=True;
  {$IFDEF TestCODE}  L_RecITestMe.ITestCode:=nil;;  {$ENDIF}
  {$IFDEF TestSEND}  L_RecITestMe.ITestSend:=nil;    {$ENDIF}

    {$IFDEF DLL_Load_Res}
      ResStream := TResourceStream.Create(HInstance, 'TESTMEDLL', RT_RCDATA);
      ResStream.Position := 0;
      L_iDLL_Size := ResStream.Size;
      L_pDLL_Data := GetMemory(L_iDLL_Size);
      ResStream.Read(L_pDLL_Data^, L_iDLL_Size);
      ResStream.Free;

    L_MemoryModule := BTMemoryLoadLibary(L_pDLL_Data, L_iDLL_Size);
    try
      if L_MemoryModule <> nil then begin
        @init:= BTMemoryGetProcAddress(L_MemoryModule, 'Init');
        if @init<>nil then
         init(HInstance,L_RecITestMe.bIsLicence);

         @lic := BTMemoryGetProcAddress(L_MemoryModule,'GetIsLicence');
         if @lic<>nil then
             L_bIsLicence:=lic(pData,iSize);

      {$IFDEF TestCODE}
        @getCode := BTMemoryGetProcAddress(L_MemoryModule, 'GetTestCode');
         if @getCode<>nil then
             getCode(L_RecITestMe.ITestCode);
       {$ENDIF}
       {$IFDEF TestSEND}
        @getSend := BTMemoryGetProcAddress(L_MemoryModule, 'GetTestSend');
         if @getSend<>nil then
             getSend(L_RecITestMe.ITestSend);
       {$ENDIF}

      end;
    except
     // Showmessage('An error occoured while loading the dll: ' +
     //   BTMemoryGetLastError);
    end;

    {$ELSE}
   L_hDll:=  LoadLibrary(Cons_DllName);
   if L_hDll<>0 then begin
     @init := GetProcAddress(L_hDll, 'Init');
        if @init<>nil then
         init(HInstance,L_RecITestMe.bIsLicence);

     @lic := GetProcAddress(L_hDll, 'GetIsLicence');
     if @lic<>nil then
         L_bIsLicence:=lic(pData,iSize);

    {$IFDEF TestCODE}
     @getCode := GetProcAddress(L_hDll, 'GetTestCode');
     if @getCode<>nil then
         getCode(L_RecITestMe.ITestCode);
      L_RecITestMe.bIsTestCode:=L_RecITestMe.ITestCode<>nil;
    {$ENDIF}
    {$IFDEF TestSEND}
     @getSend := GetProcAddress(L_hDll, 'GetTestSend');
     if @getSend<>nil then
         getSend(L_RecITestMe.ITestSend);
      L_RecITestMe.bIsTestSend:=L_RecITestMe.ITestSend<>nil;
    {$ENDIF}
   end;
    {$ENDIF}

 end;
end;



Procedure int_FreeLibrary;
var fre:TDoneFree;
begin
  {$IFDEF TestCODE}  L_RecITestMe.ITestCode:=nil;;  {$ENDIF}
  {$IFDEF TestSEND}  L_RecITestMe.ITestSend:=nil;    {$ENDIF}


    {$IFDEF DLL_Load_Res}
      if L_MemoryModule <> nil then begin
        @fre := BTMemoryGetProcAddress(L_MemoryModule, 'Done');
         if @fre<>nil then
             fre;

        BTMemoryFreeLibrary(L_MemoryModule);
        L_MemoryModule:=nil;
       FreeMemory(L_pDLL_Data);
        L_pDLL_Data:=nil;
      end;


    {$ELSE}
       if L_hDll<>0 then begin
         @fre := GetProcAddress(L_hDll, 'Done');
         if @fre<>nil then
             fre;
        freeLibrary(L_hDll);
        L_hDll:=0;

       end;
    {$ENDIF}

end;

initialization

finalization
  int_FreeLibrary;

end.
